Summary: Apache built staticly with mod_perl and php3 with imap/gd/freetype support.
Name: apache-php3perl
Version: 1.3.12
Release: 3nosyb
Group: System Environment/Daemons
Packager: Vladimir Ivaschenko <vi@maks.net>

Source0: %{name}_%{version}.tar.gz
Source1: apache-index.html
Source2: poweredby.gif
Source3: httpd.init
Source4: apache.logrotate
Source5: apache-access.conf
Source6: apache-httpd.conf
Source7: apache-srm.conf
Source8: mod_bandwidth.c
Source9: php-3.0.12.tar.gz
Source10: mod_perl-1.21.tar.gz
Source11: imap-4.5.tar.Z

%define php_dir		php-3.0.12
%define mod_perl_dir	mod_perl-1.21
%define imap_dir	imap-4.5

Patch0: apache_1.3.6-redhat.patch
Patch1: apache-1.3.11-apxs.patch
Patch2: apache_1.3.11-phhttpd.patch
Patch3: apache_1.3.12-eapi-2.6.0.patch

Patch11:    php-configure.patch
Patch15:    php-3.0.12-config.patch
Patch20:    mod_perl-1.21-rh.patch
Patch30: imap-4.5-linux.patch
Patch31: imap-4.4-vfs.patch
Patch32: imap-4.5-redhat.patch

Copyright: Freely distributable and usable
BuildRoot: /var/tmp/apache-root
BuildPrereq: gd-devel freetype-devel
Requires: /etc/mime.types gd freetype
Prereq: /sbin/chkconfig, /bin/mktemp, /bin/rm, mailcap, grep, textutils
Provides: webserver mod_perl php
Conflicts: apache

%description
Apache is a powerful, full-featured, efficient and freely-available
Web server. Apache is also the most popular Web server on the
Internet.

The version has mod_php3 (with IMAP/gd/freetype support) and 
mod_perl compiled in staticly.
Install the apache package if you need a Web server.

%package devel
Group: Development/Libraries
Summary: Development tools for the Apache Web server.
Obsoletes: secureweb-devel

%description devel
The apache-devel package contains the source code for the Apache
Web server and the APXS binary you'll need to build Dynamic
Shared Objects (DSOs) for Apache.

If you are installing the Apache Web server, and you want to be 
able to compile or develop additional modules for Apache, you'll 
need to install this package.

%prep
%setup -n %{name}_%{version}
%patch0 -p1 -b .redhat
%patch1 -p1 -b .apxs
%patch2 -p1 -b .phttpd
%patch3 -p1 -b .eapi

rm -rf %mod_perl_dir
rm -rf %php_dir
rm -rf %imap_dir
tar zxf %{SOURCE9}
tar zxf %{SOURCE10}
tar zxf %{SOURCE11}
cd %mod_perl_dir
%patch20 -p1
cd ..
cd %imap_dir
%patch30 -p1 -b .linux
%patch31 -p1 -b .vfs
%patch32 -p1 -b .redhat
cd ..
cd %php_dir
%patch11 -p0
%patch15 -p1

%build
rm -rf $RPM_BUILD_ROOT
OPTIM="$RPM_OPT_FLAGS" \
	./configure --prefix=/usr \
	--with-layout=RedHat \
	--add-module=%{SOURCE8} \
	--enable-module=all \
	--enable-shared=max \
	--enable-rule=EAPI \
	--disable-rule=WANTHSREGEX \
	--disable-module=auth_dbm \
	--with-perl=/usr/bin/perl \
	--enable-suexec \
	--suexec-docroot=/home/httpd/html \
	--suexec-caller=apache 
cd %mod_perl_dir
perl Makefile.PL APACHE_SRC=$RPM_BUILD_DIR/%{name}_%{version}/src DO_HTTPD=1 PREP_HTTPD=1 USE_APACI=1 EVERYTHING=1
make
make pure_install PREFIX=$RPM_BUILD_ROOT/usr
mkdir -p $RPM_BUILD_ROOT/home/httpd/html/manual/mod
install -m 644 htdocs/manual/mod/mod_perl.html \
	$RPM_BUILD_ROOT/home/httpd/html/manual/mod

PACKLIST=$RPM_BUILD_ROOT/usr/lib/perl5/site_perl/5.005/%{_arch}-linux/auto/mod_perl/.packlist
mv $PACKLIST $PACKLIST.old
sed -e "s|$RPM_BUILD_ROOT||g" < $PACKLIST.old > $PACKLIST
rm -f $PACKLIST.old
find $RPM_BUILD_ROOT -type f -o -type l | \
	grep -v "/home/httpd/icons" | grep -v "manual/mod" | sed -e "s|$RPM_BUILD_ROOT||g" > ../file-list.lst
cd faq; make

cd ../..
cd %imap_dir
make RPM_OPT_FLAGS="$RPM_OPT_FLAGS -fPIC" lnp
ln -s ../c-client ../%{imap_dir}/c-client/include
ln -s ../c-client ../%{imap_dir}/c-client/lib
cd ..
cd %php_dir
CFLAGS="-fPIC" ./configure --prefix=/usr \
--with-apache=$RPM_BUILD_DIR/%{name}_%{version} \
--with-config-file-path=/etc/httpd --enable-safe-mode \
--with-exec-dir=/usr/bin --with-system-regex --disable-debug --with-zlib \
--enable-debugger --enable-magic-quotes --enable-track-vars \
--with-imap=$RPM_BUILD_DIR/%{name}_%{version}/imap-4.5/c-client --with-gd --with-ttf
make
make install
cd convertor
make
cd ..
mkdir -p $RPM_BUILD_ROOT/etc/httpd
mkdir -p $RPM_BUILD_ROOT/home/httpd/icons
mkdir -p $RPM_BUILD_ROOT/usr/bin
install -m 644 php3.ini-dist $RPM_BUILD_ROOT/etc/httpd/php3.ini
install -m 644 extra/icons/*.gif $RPM_BUILD_ROOT/home/httpd/icons
install -m 755 convertor/convertor $RPM_BUILD_ROOT/usr/bin
mv convertor/README convertor/README.convertor
cd ..
OPTIM="$RPM_OPT_FLAGS" \
	./configure --prefix=/usr \
	--with-layout=RedHat \
	--add-module=%{SOURCE8} \
	--enable-module=all \
	--enable-shared=max \
	--disable-rule=WANTHSREGEX \
	--enable-rule=EAPI \
	--disable-module=auth_dbm \
	--with-perl=/usr/bin/perl \
	--enable-suexec \
	--suexec-docroot=/home/httpd/html \
	--suexec-caller=apache \
	--activate-module=src/modules/perl/libperl.a \
	--activate-module=src/modules/php3/libphp3.a
make
	
%install
make install root=$RPM_BUILD_ROOT
strip $RPM_BUILD_ROOT/usr/sbin/httpd

# remove apachectl; we have our own SYSV init stuff
rm $RPM_BUILD_ROOT/usr/sbin/apachectl
rm $RPM_BUILD_ROOT/usr/man/man8/apachectl.8

# install SYSV init stuff
mkdir -p $RPM_BUILD_ROOT/etc/rc.d/init.d
install -m755 $RPM_SOURCE_DIR/httpd.init \
	$RPM_BUILD_ROOT/etc/rc.d/init.d/httpd

for I in 0 1 2 6; do
	mkdir -p $RPM_BUILD_ROOT/etc/rc.d/rc$I.d
	ln -s ../init.d/httpd $RPM_BUILD_ROOT/etc/rc.d/rc$I.d/K15httpd
done
for I in 3 5; do
	mkdir -p $RPM_BUILD_ROOT/etc/rc.d/rc$I.d
	ln -s ../init.d/httpd $RPM_BUILD_ROOT/etc/rc.d/rc$I.d/S85httpd
done

# install log rotation stuff
mkdir -p $RPM_BUILD_ROOT/etc/logrotate.d
install -m644 $RPM_SOURCE_DIR/apache.logrotate \
	$RPM_BUILD_ROOT/etc/logrotate.d/apache

ln -s ../../var/log/httpd $RPM_BUILD_ROOT/etc/httpd/logs
ln -s ../../usr/lib/apache $RPM_BUILD_ROOT/etc/httpd/modules

install -m644 $RPM_SOURCE_DIR/apache-index.html \
        $RPM_BUILD_ROOT/home/httpd/html/index.html
install -m644 $RPM_SOURCE_DIR/poweredby.gif \
	$RPM_BUILD_ROOT/home/httpd/html

# replace Apache's default config files with our own versions
install -m644 $RPM_SOURCE_DIR/apache-access.conf \
	$RPM_BUILD_ROOT/etc/httpd/conf/access.conf

install -m644 $RPM_SOURCE_DIR/apache-httpd.conf \
	$RPM_BUILD_ROOT/etc/httpd/conf/httpd.conf

install -m644 $RPM_SOURCE_DIR/apache-srm.conf \
	$RPM_BUILD_ROOT/etc/httpd/conf/srm.conf

# install apache source code for devel package
#mkdir -p $RPM_BUILD_ROOT/usr/src
#tar xzf $RPM_SOURCE_DIR/%{name}_%{version}.tar.gz -C $RPM_BUILD_ROOT/usr/src
find $RPM_BUILD_ROOT -type f | \
	xargs grep -l "/usr/local/bin/perl5" | \
	xargs perl -pi -e "s|/usr/local/bin/perl5|/usr/bin/perl|g;"
find $RPM_BUILD_ROOT -type f | \
	xargs grep -l "/usr/local/bin/perl" | \
	xargs perl -pi -e "s|/usr/local/bin/perl|/usr/bin/perl|g;"

mkdir mod_perl-docs

cp -Rf %mod_perl_dir/CREDITS %mod_perl_dir/Changes %mod_perl_dir/README \
   %mod_perl_dir/SUPPORT %mod_perl_dir/ToDo %mod_perl_dir/cgi_to_mod_perl.pod \
   %mod_perl_dir/mod_perl.pod %mod_perl_dir/mod_perl_method_handlers.pod \
   %mod_perl_dir/mod_perl_traps.pod %mod_perl_dir/mod_perl_tuning.pod \
   %mod_perl_dir/INSTALL %mod_perl_dir/faq/*.html %mod_perl_dir/eg \
   %mod_perl_dir/faq %mod_perl_dir/ToDo %mod_perl_dir/apache-modlist.html \
   mod_perl-docs

mkdir php-docs

cp -Rf %php_dir/CODING_STANDARDS %php_dir/CREDITS %php_dir/ChangeLog \
    %php_dir/LICENSE %php_dir/BUGS %php_dir/examples %php_dir/INSTALL* \
    %php_dir/convertor/README.convertor php-docs


%clean
rm -rf $RPM_BUILD_ROOT

%post
/sbin/chkconfig --add httpd
[ -f /etc/mime.types ] || exit 0
# safely add .htm to mime types if it is not already there
TEMPTYPES=`/bin/mktemp /tmp/mimetypes.XXXXXX`
[ -z "$TEMPTYPES" ] && {
  echo "could not make temporary file, htm not added to /etc/mime.types" >&2
  exit 1
}
( grep -v "^text/html"  /etc/mime.types
  types=$(grep "^text/html" /etc/mime.types | cut -f2-)
  echo -en "text/html\t\t\t"
  for val in $types ; do
      if [ "$val" = "htm" ] ; then
          continue
      fi
      echo -n "$val "
  done
  echo "htm"
) > $TEMPTYPES
cat $TEMPTYPES > /etc/mime.types && /bin/rm -f $TEMPTYPES

%preun
if [ $1 = 0 ]; then
   /etc/rc.d/init.d/httpd stop > /dev/null 2>&1
   /sbin/chkconfig --del httpd
   /bin/rm -fr /var/log/httpd/*
fi

%files -f file-list.lst
%defattr(-,root,root)
%dir /etc/httpd/conf
%config /etc/httpd/conf/access.conf
%config /etc/httpd/conf/srm.conf
%config /etc/httpd/conf/httpd.conf
%config /etc/httpd/conf/magic

/etc/httpd/logs
/etc/httpd/modules
%config /etc/logrotate.d/apache
%config /etc/rc.d/init.d/httpd
%config(missingok) /etc/rc.d/rc3.d/S85httpd
%config(missingok) /etc/rc.d/rc5.d/S85httpd
%config(missingok) /etc/rc.d/rc0.d/K15httpd
%config(missingok) /etc/rc.d/rc1.d/K15httpd
%config(missingok) /etc/rc.d/rc2.d/K15httpd
%config(missingok) /etc/rc.d/rc6.d/K15httpd

%dir /home/httpd
%dir /home/httpd/cgi-bin
%dir /home/httpd/html

%doc mod_perl-docs
%dir /usr/lib/perl5/site_perl/5.005/%{_arch}-linux/auto/Apache
%dir /usr/lib/perl5/site_perl/5.005/%{_arch}-linux/auto/Apache/Leak
%dir /usr/lib/perl5/site_perl/5.005/%{_arch}-linux/auto/Apache/Symbol
%dir /usr/lib/perl5/site_perl/5.005/%{_arch}-linux/auto/mod_perl
%dir /usr/lib/perl5/site_perl/5.005/%{_arch}-linux/Apache/Constants
%dir /usr/lib/perl5/site_perl/5.005/%{_arch}-linux/Bundle

%config /etc/httpd/php3.ini
/home/httpd/icons/*
%doc php-docs

%config(noreplace) /home/httpd/html/index.html
/home/httpd/html/poweredby.gif
/home/httpd/html/manual
#/home/httpd/icons

/usr/lib/apache
/usr/man/*/*
/usr/sbin/ab
/usr/sbin/httpd
/usr/sbin/logresolve
/usr/sbin/rotatelogs
%attr(4711,root,root) /usr/sbin/suexec
/usr/bin/*

%attr(-,apache,apache) %dir /var/cache/httpd
%dir /var/log/httpd

%files devel
%defattr(-,root,root)
/usr/include/apache
/usr/sbin/apxs


%changelog

* Mon Mar 27 2000 Vladimir Ivaschekno <vi@maks.net>
- Upgrade to 1.3.11 from RawHide
- Build with EAPI

* Thu Dec 30 1999 Vladimir Ivaschenko <vi@maks.net>
- Rename to apache-php3perl

* Wed Dec 29 1999 Vladimir Ivaschenko <vi@maks.net>
- Use version 2.0 of mod_bandwidth

* Mon Dec 28 1999 Vladimir Ivaschenko <vi@maks.net>
- Reorganized to build with mod_perl and php3 staticly compiled.

* Tue Sep 21 1999 Bill Nottingham <notting@redhat.com>
- move DSO in httpd.conf to after ServerRoot

* Mon Sep 20 1999 Preston Brown <pbrown@redhat.com>
- it is httpd stop, not httpsd stop (# 5254)
- suexec added (# 5257)

* Thu Sep 09 1999 Preston Brown <pbrown@redhat.com>
- remove apachectl man page (# 4459)

* Fri Aug 27 1999 Preston Brown <pbrown@redhat.com>
- upgraded to 1.3.9
- fix bug # 3680 (suexec docroot was wrong)
- fix bug # 2378 (logrotate with -USR1 not -HUP)
- fix bug # 3548 (logrotate complains if apache not running)
- httpd.conf is now in the unified apache format as distributed

* Mon Aug 16 1999 Bill Nottingham <notting@redhat.com>
- initscript munging

* Sat May 21 1999 Bill Nottingham <notting@redhat.com>
- fix broken link in index.html

* Wed Apr 07 1999 Bill Nottingham <notting@redhat.com>
- allow indexes in /doc

* Tue Apr 06 1999 Preston Brown <pbrown@redhat.com>
- strip binaries

* Mon Apr 05 1999 Preston Brown <pbrown@redhat.com>
- prerequire /bin/rm, added /doc path pointing to /usr/doc for localhost

* Fri Mar 26 1999 Preston Brown <pbrown@redhat.com>
- updated log rotating scripts to not complain if logs aren't present.

* Thu Mar 25 1999 Preston Brown <pbrown@redhat.com>
- fixed up path to perl

* Wed Mar 24 1999 Preston Brown <pbrown@redhat.com>
- updated init script to conform to new standards
- upgraded to 1.3.6, fixed apxs patch

* Mon Mar 22 1999 Preston Brown <pbrown@redhat.com>
- clean up logfiles on deinstallation

* Sun Mar 21 1999 Cristian Gafton <gafton@redhat.com> 
- auto rebuild in the new build environment (release 4)

* Fri Mar 12 1999 Cristian Gafton <gafton@redhat.com>
- added mod_bandwidth
- updated to 1.3.4
- prereq mailcap

* Fri Dec 18 1998 Cristian Gafton <gafton@redhat.com>
- added patch to disable building support for ndbm
- build against glibc 2.1

* Mon Oct 12 1998 Cristian Gafton <gafton@redhat.com>
- updated to 1.3.3 to catch up with bug fixes
- added the /usr/bin/* binaries to the spec file list

* Fri Sep 25 1998 Cristian Gafton <gafton@redhat.com>
- change ownership of cache dir to nobody
- added "Red Hat" to the server string
- updated to version 1.3.2
- fixed all references to httpsd in config files

* Fri Sep 04 1998 Cristian Gafton <gafton@redhat.com>
- small fixes to the spec file
- patch to handle correctly the -d <newroot> option
- leave out the .usr.src.apache_%{version} for now

* Thu Sep 03 1998 Preston Brown <pbrown@redhat.com>
- patched apxs not to bomb out if it can't find httpd

* Wed Sep 02 1998 Preston Brown <pbrown@redhat.com>
- upgraded to apache 1.3.1.
- Heavy rewrite.
- changed providing a_web_server to just webserver.  Humor is not an option.

* Mon Aug 10 1998 Erik Troan <ewt@redhat.com>
- updated to build as non-root user
- added patch to defeat header dos attack

* Thu May 07 1998 Prospector System <bugs@redhat.com>
- translations modified for de, fr, tr

* Wed May 06 1998 Cristian Gafton <gafton@redhat.com>
- fixed the default config files to be more paranoid about security

* Sat May 02 1998 Cristian Gafton <gafton@redhat.com>
- fixed init script
- added index.htm to the list of acceptable indexes

* Sat May 02 1998 Cristian Gafton <gafton@redhat.com>
- updated to 1.2.6
- added post script to install htm extension for text/html into
  /etc/mime.types

* Wed Apr 22 1998 Michael K. Johnson <johnsonm@redhat.com>
- enhanced sysv init script

* Tue Jan 06 1998 Erik Troan <ewt@redhat.com>
- updated to 1.2.5, which includes many security fixes

* Wed Dec 31 1997 Otto Hammersmith <otto@redhat.com>
- fixed overkill on http.init stop

* Wed Dec 31 1997 Erik Troan <ewt@redhat.com>
- added patch for backslash DOS attach

* Thu Nov 06 1997 Donnie Barnes <djb@redhat.com>
- added htdigest binary to file list

* Mon Nov 03 1997 Donnie Barnes <djb@redhat.com>
- made the default index.html be config(noreplace) so we no longer
  blow away other folks' index.html

* Wed Oct 29 1997 Donnie Barnes <djb@redhat.com>
- added chkconfig support
- added restart|status options to initscript
- renamed httpd.init to httpd

* Tue Oct 07 1997 Elliot Lee <sopwith@redhat.com>
- Redid spec file, patches, etc. from scratch.
